<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '~/mixins/is-mobile.mixin.ts';

export default Vue.extend({
  name: 'QuotesCarousel',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      visibleQuote: 0,
    };
  },
  methods: {
    goToNext() {
      if (this.visibleQuote >= this.data.case_studies.length - 1) {
        this.visibleQuote = 0;
      } else {
        this.visibleQuote++;
      }
    },
    goToPrev() {
      if (this.visibleQuote === 0) {
        this.visibleQuote = this.data.case_studies.length - 1;
      } else {
        this.visibleQuote--;
      }
    },
    selectNewSlide(index) {
      this.visibleQuote = index;
    },
  },
});
</script>

<template>
  <div
    :id="data.id || ''"
    class="quotes-block"
    :class="{ 'quotes-block--white-bg': data.white_bg }"
    aria-roledescription="carousel"
    aria-label="Quotes Carousel"
  >
    <SlpContainer class="wrapper">
      <SlpTypography
        v-if="data.header"
        variant="heading2-bold"
        tag="h3"
        class="slp-mb-32"
        >{{ data.header }}</SlpTypography
      >
      <div :class="{ 'cta-container': data.customers_cta }">
        <div ref="scroll" class="logos">
          <button
            v-for="(logo, index) in data.case_studies"
            :key="logo.logo_url"
            type="button"
            :aria-label="`Select ${logo.institution_name} case study`"
            :tabindex="index === visibleQuote ? '-1' : 0"
            class="logo"
            :class="index === visibleQuote ? 'active' : ''"
            :aria-selected="index === visibleQuote"
            @click="selectNewSlide(index)"
          >
            <img :src="logo.logo_url" alt="" aria-label="" />
          </button>
        </div>
        <SlpButton
          v-if="data.customers_cta && !isMobile"
          class="cta"
          :href="data.cta?.href ?? '/customers/'"
          :data-ga-name="data.cta?.data_ga_name ?? 'customers'"
          :data-ga-location="data.cta?.data_ga_location ?? 'body'"
          variant="tertiary"
          >{{ data.cta?.text ?? 'View more stories' }}
          <SlpIcon variant="product" name="chevron-lg-right"
        /></SlpButton>
      </div>
      <div class="case-studies">
        <transition name="fade" mode="out-in" tag="div">
          <div :key="visibleQuote" class="case-studies__card">
            <SlpRow
              aria-roledescription="slide"
              :aria-label="`${visibleQuote} of ${data.case_studies.length}`"
            >
              <SlpColumn
                v-if="data.case_studies[visibleQuote].quote.img_url"
                :cols="6"
              >
                <img
                  loading="lazy"
                  :src="data.case_studies[visibleQuote].quote.img_url"
                  alt=""
                  class="slide-image"
                />
              </SlpColumn>
              <SlpColumn
                :cols="data.case_studies[visibleQuote].quote.img_url ? 6 : 12"
                class="content"
              >
                <figure>
                  <img
                    v-if="data.logo_in_card"
                    class="slp-mb-16"
                    :src="data.case_studies[visibleQuote].logo_url"
                  />
                  <SlpIcon
                    variant="marketing"
                    name="quote"
                    size="md"
                    class="quote-mark"
                  />
                  <SlpTypography variant="quotes" tag="blockquote">
                    {{ data.case_studies[visibleQuote].quote.quote_text }}"
                  </SlpTypography>
                  <SlpTypography variant="body3" tag="figcaption">
                    <strong>{{
                      data.case_studies[visibleQuote].quote.author
                    }}</strong>
                    <span>
                      {{ data.case_studies[visibleQuote].quote.author_title }}
                    </span>
                  </SlpTypography>
                </figure>
                <SlpButton
                  v-show="data.case_studies[visibleQuote].case_study_url"
                  variant="primary"
                  :href="data.case_studies[visibleQuote].case_study_url"
                  :data-ga-name="data.case_studies[visibleQuote].data_ga_name"
                  :data-ga-location="
                    data.case_studies[visibleQuote].data_ga_location
                  "
                  >{{ $t('cta_text') }}
                  <SlpIcon variant="product" name="chevron-lg-right"
                /></SlpButton>
              </SlpColumn>
            </SlpRow>
          </div>
        </transition>

        <SlpRow v-if="data.case_studies.length > 1" class="controls">
          <SlpButton
            variant="icon"
            aria-label="View previous case study"
            @click.native="goToPrev"
          >
            <SlpIcon
              name="chevron-lg-left"
              alt="Chevron Left Icon"
              variant="product"
              hex-color="#171321"
            />
          </SlpButton>
          <div class="controls__pages">
            <div
              v-for="(option, index) in data.case_studies.length"
              :key="option"
              :class="[
                option === visibleQuote + 1
                  ? 'controls__pages-control--active'
                  : '',
                'controls__pages-control',
              ]"
              @click="selectNewSlide(index)"
            ></div>
          </div>
          <SlpButton
            variant="icon"
            aria-label="View next case study"
            @click.native="goToNext"
          >
            <SlpIcon
              name="chevron-lg-right"
              alt="Chevron Right Icon"
              variant="product"
              hex-color="#171321"
            />
          </SlpButton>
        </SlpRow>
        <SlpButton
          v-if="isMobile"
          class="cta slp-mt-24"
          :href="data.cta?.href ?? '/customers/'"
          :data-ga-name="data.cta?.data_ga_name ?? 'customers'"
          :data-ga-location="data.cta?.data_ga_location ?? 'body'"
          variant="tertiary"
          >{{ data.cta?.text ?? 'View more stories' }}
          <SlpIcon variant="product" name="chevron-lg-right"
        /></SlpButton>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.quotes-block {
  padding-top: 96px;
  padding-bottom: $spacing-96;
  position: relative;
  box-shadow: 0 0 0 100vw $color-surface-800;
  clip-path: inset(0 -100vw);
  background: $color-surface-800;
  &--white-bg {
    background: none;
  }
  z-index: -1;
}

.quote-mark {
  margin-bottom: 16px;
}

.cta-container {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  .logos .logo img {
    max-width: 150px;
  }

  .cta {
    margin-bottom: $spacing-16;
    text-align: left;
  }
  @media (min-width: $breakpoint-lg) {
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
  }
}
.wrapper {
  @media (max-width: $breakpoint-md) {
    padding: 0 0 $spacing-48;
  }
}

.logos {
  display: flex;
  justify-content: space-between;
  align-items: center;
  margin-bottom: $spacing-32;
  gap: 24px;
  @media (max-width: $breakpoint-md) {
    overflow-x: scroll;
    -ms-overflow-style: none; /* Internet Explorer 10+ */
    scrollbar-width: none; /* Firefox */

    &::-webkit-scrollbar {
      display: none; /* Safari and Chrome */
    }
  }
}

.logo {
  flex: 0 0 130px;
  min-height: 85px;
  width: 100%;
  border-top: none;
  border-left: none;
  border-right: none;
  border-bottom: none;
  cursor: pointer;

  @media (max-width: $breakpoint-md) {
    flex: 0 0 80px;
    aspect-ratio: 3/2;
    object-fit: contain;
  }

  img {
    margin-bottom: 4px;
    -webkit-transform: translate3d(0, 0, 0);
    transform: translate3d(0, 0, 0);
    max-width: 200px;
  }
}

.case-studies {
  @media (max-width: $breakpoint-md) {
    margin: 0 $spacing-16;
  }

  &__card {
    height: 100%;
    display: flex;
    position: relative;
    flex-direction: column;
    align-items: flex-start;
    isolation: isolate;
    will-change: contents;

    :deep(strong) {
      font-weight: $font-weight-bold;
    }

    .slp-col-md-5,
    .slp-col-md-7 {
      height: 460px;
    }
  }

  .slp-col-md-6 {
    position: relative;
  }

  .slide-image {
    width: 100%;
    min-height: 100%;
    max-height: 460px;
    height: 100%;
    display: block;
    object-fit: cover;
    border-radius: 4px 0 0 4px;

    @media (max-width: $breakpoint-md) {
      aspect-ratio: 1.5/1;
      min-height: 0;
      max-height: 400px;
    }
  }

  .content {
    padding: $spacing-32;
    display: flex;
    flex-direction: column;
    justify-content: center;

    figcaption {
      margin-top: $spacing-8;
      margin-bottom: $spacing-24;
    }

    span {
      display: block;
    }

    .slp-btn {
      max-width: 200px;
    }

    .slp-icon {
      margin-left: 4px;
    }
  }

  .controls {
    display: flex;
    align-items: center;
    justify-content: center;
    margin-top: $spacing-24;

    color: #171321;

    :deep {
      svg,
      path {
        fill: #171321 !important;
        stroke: #171321 !important;
      }
    }

    &__pages {
      display: inherit;

      &-control {
        background: $color-surface-300;
        border-radius: 50%;
        width: 10px;
        height: 10px;
        margin: 0 $spacing-8;
        cursor: pointer;

        &:hover {
          background: $color-accent-500;
        }

        &--active {
          background: $color-surface-700;
        }
      }
    }
  }
}
</style>
